/*************************************************************************
 *                                                                       *
 * GLE - Graphics Layout Engine <http://www.gle-graphics.org/>           *
 *                                                                       *
 * BSD License                                                           *
 *                                                                       *
 * Copyright (c).                                                        *
 * All rights reserved.                                                  *
 *                                                                       *
 * Redistribution and use in source and binary forms, with or without    *
 * modification, are permitted provided that the following conditions    *
 * are met:                                                              *
 *                                                                       *
 *  * Redistributions of source code must retain the above copyright     *
 *  notice, this list of conditions and the following disclaimer.        *
 *                                                                       *
 *  * Redistributions in binary form must reproduce the above            *
 *  copyright notice, this list of conditions and the following          *
 *  disclaimer in the documentation and/or other materials provided      *
 *  with the distribution.                                               *
 *                                                                       *
 *  * Neither the name of GLE nor the names of its contributors may      *
 *  be used to endorse or promote products derived from this software    *
 *  without specific prior written permission.                           *
 *                                                                       *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     *
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR *
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  *
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, *
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      *
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, *
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY *
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   *
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE *
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  *
 *                                                                       *
 *************************************************************************/

#include "all.h"
#include "SourceLine.h"
#include "gprint.h"

void polar_xy(double r, double angle, double *dx, double *dy);
void xy_polar(double dx,double dy,double *radius,double *angle);

int glefitcf_(int *mode,float *x, float *y, int *l, int *m, float *u, float *v, int *n);
void fitbez(double **pxv, double **pyv, int **pmv,int *pnp, int multivalued)
{
	double *xv, *yv;
	int *m;
	int n,i;
	float *xin,*yin,*xout,*yout,*xx,*yy,*xxout,*yyout;
	int mode,nsub,outp,ninp;


	if (*pnp>138  || *pnp<=2) return;
	xin = (float*) myallocz(*pnp*sizeof(*xin));
	yin = (float*) myallocz(*pnp*sizeof(*xin));
	xout = (float*) myallocz(300*sizeof(*xin));
	yout = (float*) myallocz(300*sizeof(*xin));
	xxout = xout; yyout = yout;
	/* myfree(*pmv); */
	*pmv = (int*) myallocz(300*sizeof(i));

	xv = *pxv;
	yv = *pyv;
	xx = xin; yy = yin;
	for (i=0;i<*pnp;i++) {
		*xx++ = *xv++;
		*yy++ = *yv++;
	}
	mode = 1;
	if (multivalued) mode=2;
	nsub = 280/(*pnp-1);
	outp = 300;
	outp = (*pnp-1)*nsub+1;
	ninp = *pnp;
	glefitcf_(&mode,xin,yin,&ninp,&nsub,xout,yout,&outp);
	xv = (double*) myallocz(300*sizeof(*xv));
	yv = (double*) myallocz(300*sizeof(*xv));
	/* myfree(*pxv); 	myfree(*pyv); */
	*pxv = xv;
	*pyv = yv;
	*pnp = outp;
	for (i=0;i<*pnp;i++) {
		*xv++ = *xout++;
		*yv++ = *yout++;
	}
	/* should call FREE to deal old points */
	m = *pmv;
	for (i=0;i<=*pnp;i++) *m++ = 0;	/* no missing values */

	myfree(xin);
	myfree(yin);
	myfree(xxout);
	myfree(yyout);
}


